;Coloque los dip switches en cualquier posicin. El programa 
;lee un nmero n (0..15) de los dip switches y lo escribe en 
;el puerto B. En el momento en que el programa detecta algn 
;cambio de valor en cualquiera de los dip switches, los lee 
;de nuevo, en un nmero m (0..15),y muestra el resultado de 
;(n+m) en los leds del puerto B. Fin del programa.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J			equ	H'80'	  
K			equ	H'81'
L			equ H'82'
CLAVE100 	equ	H'83'
CLAVE101 	equ	H'84'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		call 	lee_dip
		MOVF	CLAVE100,w
		MOVWF	CLAVE101
REPITE:	call    lee_dip
		MOVF	CLAVE100,w
		XORWF	CLAVE101,w
		BTFSS	STATUS,Z
		GOTO	CAMBIO
		GOTO	REPITE
CAMBIO: MOVF	CLAVE100,w
		ADDWF	CLAVE101,w
		MOVWF	PORTB
		SLEEP

lee_dip:BOLTSWITCH		;esta subrutina evita que el ensamblador marque error
		return			;al llamar varias veces al macro BOLTSWITCH.
		
		end



