;Realice un programa que almacene en localidades de la memoria
;de cdigo del microcontrolador una tabla T[n] mediante las 
;instrucciones retlw, con los siguientes 16 datos hexadecimales: 
;Inicio de tabla 00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F
;Muestre en los leds, LED7..LED0, en cdigo binario, el valor de 
;la suma de todos los elementos de la tabla desde el T[0] hasta el 
;T[n], en donde n es el valor ledo de los 4 dip switches. 
;Por ejemplo, si n=4, el valor mostrado en los leds es de 10 (0AH). 
;Si n=10, el valor mostrado es 55 (37H). Si n=15, el valor mostrado 
;ser 120 (78H).
;Nota importante: el programa deber funcionar igualmente si los 
;valores de la tabla se modifican.


	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J			equ	H'80'	  
K			equ	H'81'
L			equ H'82'
CLAVE100 	equ H'83'
contador 	EQU H'84'
suma		equ H'85'
	 
		org 	0x800		;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		BOLTSWITCH
		incf	CLAVE100
		movlw	9
		movwf	PCLATH		;INICIALIZA PARA EL MANEJO DE LA TABLA
		clrf 	contador
		clrf	suma
loop:	movf	contador,w
		call	tabla
		addwf	suma
		incf	contador
		incf	contador	;siguiente elemento de la tabla
		decfsz	CLAVE100		
		goto	loop
		movf	suma,w
		movwf	PORTB
		sleep

		org		0x900		
tabla:	addwf	PCL,f
		retlw	H'00'
		retlw	H'01'
		retlw	H'02'
		retlw	H'03'
		retlw	H'04'
		retlw	H'05'
		retlw	H'06'
		retlw	H'07'
		retlw	H'08'
		retlw	H'09'
		retlw	H'0A'
		retlw	H'0B'
		retlw	H'0C'
		retlw	H'0D'
		retlw	H'0E'
		retlw	H'0F'
		

		end

