;Despus de reset, todos los leds estn apagados y SW1 puede estar en
;cualquier posicin (ON u OFF). Cada vez que el usuario cambie SW1 de 
;posicin, se incrementa la cuenta en el puerto B con un retraso de 200 ms.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
SU	equ	H'83'


		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		btfss	SW1		;lectura inicial de SW1
		goto	cero
uno:	movlw	0xFF
		movwf	SU		;SU=0xFF
		goto 	malla
cero:	clrf	SU		;SU=0x00
malla:	comf	SU,f	;complementa SU
conti2:	btfss	SW1		
		goto	cero1
		movlw	0xFF
		goto	conti
cero1:	movlw	0
conti:	xorwf	SU,w	;compara con lectura anterior de SU
		btfss	STATUS,Z
		goto	conti2
cambio: incf	PORTB
		call	retrobolt
		goto	malla

;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'12'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return
		end	

