;Si SW1=OFF, el programa realiza un corrimiento circular 
;(sin carry)hacia la izquierda encendiendo los leds uno 
;a uno con un perodo de 200 ms. Si SW1=ON, el corrimiento 
;se har hacia la derecha. 
;Si el usuario modifica el valor de SW1, la direccin del 
;corrimiento se modificar instantneamente, de acuerdo al 
;nuevo valor.
;En cualquier caso, si SW4=OFF, el corrimiento en los leds 
;se detendr, y si SW4=ON, continuar.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		bsf		LED0
loop:	btfss	SW1
		goto	der
		goto	izq
der:	btfss	SW4
		goto	sigue1
		goto	loop
sigue1: rrncf	PORTB
		call	retrobolt
		goto	loop
izq:	btfss	SW4
		goto	sigue2
		goto	loop
sigue2	rlncf	PORTB
		call	retrobolt
		goto	loop


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'10'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

