;Realice un programa que almacene en localidades de la memoria de cdigo del 
;microcontrolador una tabla mediante las instrucciones retlw, con los siguientes 
;16 datos hexadecimales D0D15: 
;AA 20 3C 5E D9 16 0B 9F 0A 20 3C 82 71 16 FF EE
;Leer de los 4 dip switches (SW4..SW1), un dato n=0..15. 
;Mostrar en los leds el elemento Dn. retraso de 1 segundo.
;Si el usuario modifica el dato en los dip switches, los
;leds actualizarn el dato sin necesidad de oprimir el reset.



	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
CLAVE100	equ	H'83'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
loop	BOLTSWITCH
		movlw	9
		movwf	PCLATH
		rlncf	CLAVE100,f
		movf	CLAVE100,w
		call	tabla
		movwf	PORTB
		call	retrobolt

;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'180'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return

		ORG 0X900
tabla	addwf	PC,f		;AA 20 3C 5E D9 16 0B 9F 0A 20 3C 82 71 16 FF EE
		retlw	H'AA'
		retlw	H'20'
		retlw	H'3C'
		retlw	H'5E'
		retlw	H'D9'
		retlw	H'16'
		retlw	H'0B'
		retlw	H'9F'
		retlw	H'0A'
		retlw	H'20'
		retlw	H'3C'
		retlw	H'82'
		retlw	H'71'
		retlw	H'16'
		retlw	H'FF'
		retlw	H'EE'




		end	

