;Lee de los 4 dip switches un nmero n (0F) en hexadecimal. 
;Convierte a cdigo ASCII y muestra el resultado en los leds del puerto
;B. Si el usuario modifica la posicin de los switches, automticamente
;se modifica el resultado en los leds. Para convertir de hexadecimal a
;cdigos ASCII: nmeros (0..9), sumar 30H. Letras (A..F), sumar 37H

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
CLAVE100 equ H'83'
	 
		org 	0x800		;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
inicio:	BOLTSWITCH
		movf 	CLAVE100,w
		sublw 	9			;9 - w
		btfss	STATUS,N
		goto	NUMERO
		goto	LETRA
LETRA:	movf	CLAVE100,w
		addlw	0x37
		movwf	PORTB
		call	retrobolt
		goto	inicio
NUMERO:	movf	CLAVE100,w
		addlw	0x30
		movwf	PORTB
		call	retrobolt
		goto	inicio


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'61'	;valor de L. Modifique para cambiar el valor del retraso.
			movwf	L
lloop		movlw	D'255'	; w := 200 decimal
			movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
			goto 	kloop
			decfsz	J,f	; J = J-1, skip next if zero
			goto	jloop
			decfsz	L,f
			goto	lloop
			return


			end	


		end	

