;Realice un programa en lenguaje ensamblador que haga la siguiente funcin:
;Lee de los microswitches SW3..SW1, un valor entre n= 015 (en decimal).
;Activa el relevador. Genera un retraso de D= (500 ms. x n) 
;(es decir, el valor mximo es de 7.5 segundos). Apaga el relevador. 
;En el puerto B (LED3..LED0) debe observarse n en decrementos, desde su 
;valor mximo hasta que n=0.
;Si al leer los microswitches n=0, no deber activarse el relevador.
;Fin del programa


	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
CLAVE100 equ H'83'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
inicio:	BOLTSWITCH
		incf	PORTB
		bsf		RELE
loop:	decfsz	PORTB,f
		goto	sigue
		goto	fin
sigue:	call	retrobolt
		goto	loop
fin:	bcf		RELE
		sleep


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'30'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

