;Realice un programa que almacene en localidades de la memoria de cdigo del 
;microcontrolador una tabla mediante las instrucciones retlw, con los siguientes 
;8 datos hexadecimales: D4 F6 3A E0 6A 71 42 C9
;Muestre en los leds, LED3..LED0 en cdigo binario, en forma consecutiva, cada uno 
;de estos valores hexadecimales de 4 bits durante 2 segundos. Es decir, en los leds
;se mostrarn, en binario: D,4,F,6,3,A,... etc. El programa termina mostrando el
;nmero 9 en binario.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
CLAVE100 equ H'83'
X	equ	H'84'
SUMA	equ	H'85'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
inicio:	BOLTSWITCH
		movlw	9
		movwf	PCLATH	;INICIALIZA PARA EL MANEJO DE LA TABLA
		clrf	X
sigue:	movf	X,w
		call	tabla
		movwf	SUMA	;GUARDA DATO EN LOCALIDAD
		swapf	SUMA
		movf	SUMA,w
		andlw	0X0F
		movwf	PORTB
		call	retrobolt
		swapf	SUMA,f
		movf	SUMA,w
		andlw	0X0F
		movwf	PORTB
		call	retrobolt
		incf	X,f
		incf	X,f
		movlw	D'16'
		subwf	X,w
		btfss	STATUS,Z
		goto	sigue
		goto	fin
fin		sleep
		
		org		0x900		;D4 F6 3A E0 6A 71 42 C9
tabla:	addwf	PCL,f
		retlw	H'D4'
		retlw	H'F6'
		retlw	H'3A'
		retlw	H'E0'
		retlw	H'6A'
		retlw	H'71'
		retlw	H'42'
		retlw	H'C9'
		


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'122'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

