;Lee un valor m (0..3) de los dip switches SW2,SW1 y lo escribe en el 
;puerto B. Espera 3 segundos. Lee un segundo valor n (0..3) de los dip 
;switches y lo escribe en el puerto B. Espera otros 3 segundos. 
;Si SW4=OFF, escribe en el puerto B la resta de m-n (en complemento a 2). 
;Si SW4=ON, escribe en el puerto B la suma de m+n. Si el usuario mueve 
;el switch SW4, se modifica sobre la marcha el resultado en el Puerto B. 
;Para evitar que el ensamblador marque error al llamar 2 veces al macro 
;BOLTSWITCH, utilice el llamado a subrutina:
;			call lee_dip
;
;lee_dip 	BOLTSWITCH
;			return

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
m   equ H'83'
n	equ H'84'
CLAVE100 equ H'85'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		call 	lee_dip
		call	two
		movf	CLAVE100,w
		movwf	m
		movwf	PORTB
		call 	retrobolt
		call 	lee_dip
		call	two
		movf	CLAVE100,w
		movwf	n
		movwf	PORTB
		call	retrobolt
malla	btfss	SW4
		goto	suma
		goto	resta
suma	movf	n,w
		addwf	m,w
		movwf	PORTB
		goto 	malla			
resta	movf	n,w
		subwf	m,w
		movwf	PORTB
		goto	malla

two		movlw	3
		andwf	CLAVE100,f
		return

;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'180'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return

lee_dip  	BOLTSWITCH
		return

		end	

