;Lee los 4 microswitches y forma un par de nmeros: 
;SW4 y SW3 (n=0..3). SW2 y SW1 (m=0..3), en donde 
;SW4 y SW2 son los bits ms significativos.
;Si m diferente a n, flashea el led 0. 
;Si m = n, flashea el led 7. 
;Utilice retrasos de 200 ms. 
;Fin del programa. 
;Para repetir, debe darse reset al sistema.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ 	H'82'
CLAVE100 equ	H'83'
m	equ	H'84'
n	equ	H'85'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		BOLTSWITCH
		clrf	PORTB
		movf	CLAVE100,w
		movwf	m
		movwf	n
		movlw	0xC
		andwf	n,f
		rrncf	n,f
		rrncf	n,f			;forma n
		movlw	3
		andwf	m,f			;forma m
		movf	n,w
		xorwf	m,w			;compara
		btfss	STATUS,Z
		goto	distin
		goto	igual
distin	bsf		LED0
		call	retrobolt
		bcf		LED0
		call	retrobolt
		goto	distin
igual	bsf		LED7
		call	retrobolt
		bcf		LED7
		call	retrobolt
		goto	igual

		
		
		


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'61'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

